workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

variables:
  PHP_IMAGE: php:7.2

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - vendor/

before_script:
  # Install composer
  - curl -sS https://getcomposer.org/installer | php -- --install-dir=/usr/local/bin --filename=composer
  # Install libraries needed by composer
  - apt-get update && apt-get install -y git && apt-get install -y unzip
  # Intall Xdebug
  - pecl install xdebug-2.8.1 && docker-php-ext-enable xdebug

stages:
  - build
  - test

build:
  stage: build
  image: $PHP_IMAGE
  script:
    - composer install

test:
  stage: test
  image: $PHP_IMAGE
  script:
    - composer run test:ci
  artifacts:
    when: always
    reports:
      junit:
        - reports/phpunit.xml
        - reports/phpcs.xml
        - reports/psalm.xml
